/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>
#include <stdlib.h>
#include <list>
using namespace std;

#include <SDL/SDL.h>

#include "../Event_AddFO.h"
#include "../Text.h"

#include "TextElement.h"
#include "TextEventElement.h"
#include "SceneEventElement.h"
#include "TextFontElement.h"
#include "TextStringElement.h"
#include "TextLocationXElement.h"
#include "TextLocationYElement.h"
#include "TextSizeElement.h"
#include "TextStyleElement.h"
#include "TextColorElement.h"
#include "TextWaitElement.h"

TextElement::TextElement(char* super)
{
    name = "テキスト";
    superID = super;
    type = SCENEEVENT;
    elements = NULL;
}

Element* TextElement::getChild(char* name, char* super)
{
    if ( elements == NULL ) {
        elements = new list<TextEventElement*>;
    }
    if ( strcmp("フォント", name) == 0 ) {
        TextEventElement* e = new TextFontElement(super);
        elements->push_back(e);
        return e;
    }
    else if ( strcmp("文字", name) == 0 ) {
        TextEventElement* e = new TextStringElement(super);
        elements->push_back(e);
        return e;
    }
    else if ( strcmp("横位置", name) == 0 ) {
        TextEventElement* e = new TextLocationXElement(super);
        elements->push_back(e);
        return e;
    }
    else if ( strcmp("縦位置", name) == 0 ) {
        TextEventElement* e = new TextLocationYElement(super);
        elements->push_back(e);
        return e;
    }
    else if ( strcmp("サイズ", name) == 0 ) {
        TextEventElement* e = new TextSizeElement(super);
        elements->push_back(e);
        return e;
    }
    else if ( strcmp("スタイル", name) == 0 ) {
        TextEventElement* e = new TextStyleElement(super);
        elements->push_back(e);
        return e;
    }
    else if ( strcmp("色", name) == 0 ) {
        TextEventElement* e = new TextColorElement(super);
        elements->push_back(e);
        return e;
    }
    else if ( strcmp("時間", name) == 0 ) {
        TextEventElement* e = new TextWaitElement(super);
        elements->push_back(e);
        return e;
    }
    else {
        invalidElement(name);
    }

    return NULL;
}

void TextElement::endElement()
{
}

list<TextEventElement*>* TextElement::getElements(list<string>* path)
{
    checkInheritance(getElements, elements, TextElement, new list<TextEventElement*>);
    return elements;
}

SceneEvent* TextElement::getEvent()
{
    if ( event == NULL ) {
        list<TextEventElement*>* elements = getElements(NULL);
        list<TextEventElement*>::iterator i = elements->begin();
        list<TextEvent::Event*>* events = new list<TextEvent::Event*>;
        while ( i != elements->end() ) {
            events->push_back((*i)->getEvent());
            i++;
        }
        event = new Event_AddFO(Text::create(events));
    }
    return event;
}

